package com.ruoyi.project.hit.controller;

import com.ruoyi.common.utils.ServletUtils;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.framework.security.LoginUser;
import com.ruoyi.framework.web.controller.BaseController;
import com.ruoyi.framework.web.domain.AjaxResult;
import com.ruoyi.framework.web.page.TableDataInfo;
import com.ruoyi.project.hit.domain.PupuLog;
import com.ruoyi.project.hit.domain.vo.SelectLogVO;
import com.ruoyi.project.hit.service.PupuLogService;
import com.ruoyi.project.system.domain.SysUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.List;

@RestController
@RequestMapping("/hit/log")
public class PupuLogController extends BaseController {
    @Autowired
    private PupuLogService pupuLogService;

    /**
     * 日志查询（分页）
     * @param selectLogVO
     * @return
     */
    @PostMapping("/select")
    public TableDataInfo select(@RequestBody SelectLogVO selectLogVO){
        startPage();
        List<HashMap> select = pupuLogService.select(selectLogVO);
        return getDataTable(select);
    }


    /**
     * 日志表导出
     * @param selectLogVO
     * @return
     */
    @GetMapping("/export")
    public AjaxResult export(@RequestBody SelectLogVO selectLogVO)
    {
        List<PupuLog> list = pupuLogService.selectLogs(selectLogVO);
        ExcelUtil<PupuLog> util = new ExcelUtil<PupuLog>(PupuLog.class);
        return util.exportExcel(list, "日志数据");
    }

    /**
     * 日志表导入
     * @param file
     * @param updateSupport
     * @return
     * @throws Exception
     */
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file, boolean updateSupport) throws Exception
    {
        ExcelUtil<PupuLog> util = new ExcelUtil<PupuLog>(PupuLog.class);
        List<PupuLog> list = util.importExcel(file.getInputStream());
        System.out.println(list);
        if(list.size()==0){
            return AjaxResult.error("空数据");
        }
        //执行导入操作。。。
        boolean b = pupuLogService.saveBatch(list);
        if(!b){
            return AjaxResult.error("数据导入失败");
        }
        return AjaxResult.success();
    }


    /**
     * 获取导入模版
     * @return
     */
    @GetMapping("/importTemplate")
    public AjaxResult importTemplate()
    {
        ExcelUtil<PupuLog> util = new ExcelUtil<PupuLog>(PupuLog.class);
        return util.importTemplateExcel("日志数据");
    }


}
