package com.ruoyi.project.hit.domain;

import com.baomidou.mybatisplus.annotation.*;

import java.io.Serializable;
import java.util.Date;

import com.ruoyi.framework.aspectj.lang.annotation.Excel;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @TableName pupu_log
 */
@TableName(value ="pupu_log")
@Data
@AllArgsConstructor
@NoArgsConstructor
public class PupuLog implements Serializable {
    @TableId(type = IdType.AUTO)
    @Excel(name = "日志序号", cellType = Excel.ColumnType.NUMERIC, prompt = "日志编号")
    private Integer logId;

    @Excel(name = "事件")
    private String logEvent;

    @Excel(name = "事件种类", readConverterExp = "1=增,2=删,3=改")
    private Integer logSort;

    @TableField(fill = FieldFill.INSERT)
    @Excel(name = "时间", width = 30 ,dateFormat = "yyyy-MM-dd HH:mm:ss", type = Excel.Type.EXPORT)
    private Date time;

    @Excel(name = "用户id")
    private Integer userId;

    private static final long serialVersionUID = 1L;

    public PupuLog(String logEvent, Integer logSort, Date time) {
        this.logEvent = logEvent;
        this.logSort = logSort;
        this.time = time;
    }

    public PupuLog(String logEvent, Integer logSort, Date time, Integer userId) {
        this.logEvent = logEvent;
        this.logSort = logSort;
        this.time = time;
        this.userId = userId;
    }
}