package com.ruoyi.project.hit.test.alipay;






import com.alipay.api.AlipayApiException;
import com.alipay.api.internal.util.AlipaySignature;
import org.springframework.web.bind.annotation.*;

import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Random;

/**
 * 支付宝接口
 */
@RestController
@RequestMapping("/hit/alipay")
public class AliPayController {

    @Resource
    AlipayTemplate alipayTemplate;

    @GetMapping(value = "/pay/{orderId}", produces = "text/html")
    @ResponseBody
    public String pay(@PathVariable(value = "orderId") Integer orderId) throws AlipayApiException {
        Order order = new Order();
        Random random = new Random();

        // 生成一个随机的long型数据
        long randomLong = random.nextLong();
        order.setId(randomLong);
        order.setUserId(129904058947L);
        order.setInterfaceInfoId(294389472934L);
        order.setMoney(10.0);
        order.setPaymentMethod("支付宝");
        return alipayTemplate.pay(order);
    }

    @PostMapping("/notify")  // 注意这里必须是POST接口
    public String payNotify(HttpServletRequest request) throws Exception {
        if (request.getParameter("trade_status").equals("TRADE_SUCCESS")) {
            System.out.println("=========支付宝异步回调========");

            /*Map<String, String> params = new HashMap<>();
            Map<String, String[]> requestParams = request.getParameterMap();
            for (String name : requestParams.keySet()) {
                params.put(name, request.getParameter(name));
                System.out.println(name + " = " + request.getParameter(name));
            }

            String tradeNo = params.get("out_trade_no");
            String gmtPayment = params.get("gmt_payment");
            String alipayTradeNo = params.get("trade_no");

            String sign = params.get("sign");
            String content = AlipaySignature.getSignCheckContentV1(params);

            // 支付宝验签
//            System.out.println(alipayTemplate.alipayPublicKey);
//            System.out.println(alipayTemplate.getCharset());
            boolean rsa2 = AlipaySignature.rsaCheck(content,sign, alipayTemplate.alipayPublicKey, "UTF-8", "RSA2");
//            boolean checkSignature = AlipaySignature.rsa256CheckContent(content, sign, alipayTemplate.getAlipayPublicKey(), "UTF-8"); // 验证签名
            System.out.println(rsa2);
            if (Factory.Payment.Common().verifyNotify(params)) {
                // 验签通过
                System.out.println("交易名称: " + params.get("subject"));
                System.out.println("交易状态: " + params.get("trade_status"));
                System.out.println("支付宝交易凭证号: " + params.get("trade_no"));
                System.out.println("商户订单号: " + params.get("out_trade_no"));
                System.out.println("交易金额: " + params.get("total_amount"));
                System.out.println("买家在支付宝唯一id: " + params.get("buyer_id"));
                System.out.println("买家付款时间: " + params.get("gmt_payment"));
                System.out.println("买家付款金额: " + params.get("buyer_pay_amount"));
                // 更新订单状态
            }else {
                System.out.println("验签失败");
            }*/


            Map<String, String> params = new HashMap<>();
// 假设你已经有了一个方法来解析HTTP POST请求的参数
            Map<String, String[]> requestParams = request.getParameterMap();
            for (Iterator<String> iter = requestParams.keySet().iterator(); iter.hasNext();) {
                String name = iter.next();
                String[] values = requestParams.get(name);
                String valueStr = "";
                for (int i = 0; i < values.length; i++) {
                    valueStr = (i == values.length - 1) ? valueStr + values[i]
                            : valueStr + values[i] + ",";
                }
                // 乱码解决，这段代码在出现乱码时使用
//                valueStr = new String(valueStr.getBytes("ISO-8859-1"), "utf-8");
                params.put(name, valueStr);
            }

// 验签
            System.out.println(params);
            boolean isCheck = AlipaySignature.rsaCheckV1(params, alipayTemplate.getAlipayPublicKey(), "UTF-8","RSA2");
            if (isCheck) {
                System.out.println("验签成功");
                // 验签成功，处理业务逻辑
            } else {
                // 验签失败，记录日志或返回错误信息
                System.out.println("验签失败");
            }

        }
        return "success";
    }
}


