package com.ruoyi.project.hit.test.thickness;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.general.DatasetChangeEvent;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

import javax.swing.*;
import java.awt.*;

public class ChartUpdater {

    private static XYSeries series = new XYSeries("Serial Data");
    private static XYSeriesCollection dataset = new XYSeriesCollection(series);
    private static JFreeChart chart;
    private static JFrame frame;

    public static void main(String[] args) {
        chart = ChartFactory.createXYLineChart(
                "Serial Data Chart",
                "Time",
                "Value",
                dataset,
                PlotOrientation.VERTICAL,
                true, true, false);

        frame = new JFrame();
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setSize(800, 600);
        frame.add(new ChartPanel(chart));
        frame.setVisible(true);
    }

    public static synchronized void updateChart(String data) {
        try {
            double value = Double.parseDouble(data.trim());
            series.add(series.getItemCount() + 1, value);  // Assuming the x-axis is just the count of data points

            // Update the dataset and chart
//            dataset.notifyListeners(new DatasetChangeEvent(this, dataset));
        } catch (NumberFormatException e) {
            System.out.println("Invalid data received: " + data);
        }
    }
}
