package com.ruoyi.project.hit.test.thickness;

import com.fazecast.jSerialComm.SerialPort;
import org.springframework.security.core.parameters.P;

import java.util.Arrays;

public class SerialPortReader {
    public static void main(String[] args) {
        // List all available serial ports
        SerialPort[] ports = SerialPort.getCommPorts();
        for (SerialPort port : ports) {
            System.out.println(port.getSystemPortName());
        }



        SerialPort port = SerialPort.getCommPort("COM6"); // 修改为你的串口号
        port.setBaudRate(57600);
        port.setNumDataBits(8);
        port.setNumStopBits(SerialPort.ONE_STOP_BIT);
        port.setParity(SerialPort.NO_PARITY);

        if (port.openPort()) {
            System.out.println("Port opened successfully.");
            try {
                // 指令数据
                byte[] command = {0x5a, 0x00, 0x0a, 0x00, 0x00, 0x04, 0x00, (byte) 0x7d, 0x00, 0x29};

                // 发送指令
                port.writeBytes(command, command.length);
                System.out.println("Command sent."+ Arrays.toString(command));
                // 现在你可以开始读取串口数据了

                // 示例：读取串口数据
                byte[] readBuffer = new byte[1024];
                int numRead = port.readBytes(readBuffer, readBuffer.length);
                if (numRead > 0) {
                    String readData = new String(readBuffer, 0, numRead);
                    System.out.println("Read " + numRead + " bytes: " + readData);
                }

            } catch (Exception e) {
                e.printStackTrace();
            } finally {
                port.closePort(); // 关闭串口
            }
        } else {
            System.out.println("Failed to open port.");
            return;
        }


    }

    // Placeholder for the method that updates the chart
    private static void updateChart(String data) {
        // Parse the data and update the chart
        // This will be implemented in the next section
        ChartUpdater.updateChart(data);
    }
}
